/* fixedDepthSearcher2.h
 */
#ifndef _CHECKMATE_FIXED_DEPTH_SERCHER2_H
#define _CHECKMATE_FIXED_DEPTH_SERCHER2_H
#include "osl/checkmate/proofDisproof.h"
#include "osl/state/numEffectState.h"
#include "osl/move.h"
#include "osl/pieceStand.h"
#include "osl/misc/carray.h"
#include "osl/misc/fastCopier.h"
#include "osl/misc/align16New.h"

namespace osl
{
  class PieceStand;
  namespace container
  {
    class MoveVector;
  }
  namespace checkmate
  {
    /**
     * ǡοޤ depth first searchɤ;.
     * 0ǵͤ߾֤ɤ(μ֤ξ)򤫤꤬ʤȽǽ
     * 1̾ΰͤߤȽ(μ֤ξ)
     * ȤΤϿ3̤ޤ?
     * ¦μmove generationϤƤޤ(safeFilterϤʤˡǥå
     * NumEffectState
     */
    class FixedDepthSearcher2
#if OSL_WORDSIZE == 32
      : public misc::Align16New
#endif
    {
      static void copyState(NumEffectState *dest,NumEffectState * src){
	osl::misc::FastCopier::copy(dest,src);
      }
    private:
      static const int MAXDEPTH=16;
      NumEffectState *original_state;
      CArray<NumEffectState,MAXDEPTH> states;
      int count;
    public:
      FixedDepthSearcher2() : original_state(0), count(0)
      {
      }
      explicit FixedDepthSearcher2(NumEffectState& s)
	: original_state(&s), count(0)
      {
      }
      void setState(NumEffectState& s)
      {
	original_state = &s;
      }
    private:
      void addCount()
      {
	count++; 
      }
    public:
      int getCount() const
      {
	return count; 
      }
    public:
      // private: Note: helper Թ
      template <Player P, bool SetPieces, bool HasGuide>
      const ProofDisproof attack(int depth, Move& best_move, PieceStand& proof_pieces);
      template <Player P, bool SetPieces, bool HasGuide>
      const ProofDisproof attackMayUnsafe(int depth, Move& best_move, PieceStand& proof_pieces);
      template <Player P, bool SetPieces>
      const ProofDisproof defense(Move last_move,int depth,
				  PieceStand& proof_pieces);
    private:
      /**
       * move 餺 ProofDisproof ͽ¬׻
       */
      template <Player P, bool SetPieces>
      const ProofDisproof defenseEstimation(int depth,Move last_move, PieceStand& proof_pieces,
					    Piece attacker_piece,
					    Position target_position) const;
    public:      
      /**
       * stateP̤֤ͤ.
       * stateμ֤PȰפƤȤ
       */
      template <Player P>
      const ProofDisproof hasCheckmateMove(int depth, Move& best_move,
					   PieceStand& proof_pieces)
      {
	copyState(&states[depth],original_state);
	return attack<P,true,false>(depth, best_move, proof_pieces);
      }
      /**
       * guide ǽ˻
       * guide.isNormal() ǤɬפϤ뤬ζ̤valid ǤʤƤɤ
       */
      template <Player P>
      const ProofDisproof hasCheckmateWithGuide(int depth, Move& guide,
						PieceStand& proof_pieces);
      template <Player P>
      const ProofDisproof hasCheckmateMove(int depth,Move& best_move)
      {
	PieceStand proof_pieces;
	copyState(&states[depth],original_state);
	return attack<P,false,false>(depth, best_move, proof_pieces);
      }
      template <Player P>
      const ProofDisproof hasCheckmateMove(int depth)
      {
	Move checkmate_move;
	return hasCheckmateMove<P>(depth, checkmate_move);
      }
      
      /**
       * statePˤäƵͤǤ̤֤.
       * ꤬äƤʤˤϸƤФʤ
       * stateμ֤alt(P)ȰפƤȤ
       * statePˤäƲ꤬äƤȤ
       * @param last_move ǤͤȽɬ
       */
      template <Player P>
      const ProofDisproof hasEscapeMove(Move last_move,int depth,
					PieceStand& proof_pieces)
      {
	return defense<P,true>(last_move, depth, proof_pieces);
      }
      template <Player P>
      const ProofDisproof hasEscapeMove(Move last_move,int depth)
      {
	PieceStand proof_pieces;
	return defense<P,false>(last_move, depth, proof_pieces);
      }
      /**
       * next_move ؤƨ뤫ɤĴ٤
       * @param check_move ͤξι¦λؼ
       * @param depth next_move ؤ夫饫
       */
      template <Player P>
      const ProofDisproof hasEscapeByMove(Move next_move, int depth,
					  Move& check_move,
					  PieceStand& proof_pieces);
      template <Player P>
      const ProofDisproof hasEscapeByMove(Move next_move, int depth);

      const ProofDisproof hasCheckmateMoveOfTurn(int depth,Move& best_move);
      const ProofDisproof hasCheckmateMoveOfTurn(int depth,Move& best_move,
						 PieceStand& proof_pieces);
      const ProofDisproof hasCheckmateWithGuideOfTurn(int depth, Move& guide,
						      PieceStand& proof_pieces);
      const ProofDisproof hasEscapeMoveOfTurn(Move last_move,int depth);
      const ProofDisproof hasEscapeByMoveOfTurn(Move next_move, int depth,
						Move& check_move,
						PieceStand& proof_pieces);
      const ProofDisproof hasEscapeByMoveOfTurn(Move next_move, int depth);

      /**
       * ̵̹ʤ٤ʤ
       */
      template <Player Defense>
      void generateBlockingWhenLiberty0(int depth,Piece defense_king, Position attack_from,
					container::MoveVector& moves) const;
      template <Player Defense>
      int blockEstimation(Position attack_from, Position defense_king) const;
    };
  } // namespace checkmate
} // namespace osl

#endif /* _CHECKMATE_FIXED_DEPTH_SERCHER2_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
