#ifndef _NEARMASKE_H
#define _NEARMASKE_H
#include "osl/state/numEffectState.h"
#include "osl/misc/bitOp.h"
#include "osl/ptypeTraits.h"
#include <iosfwd>

namespace osl
{
  namespace container
  {
  /**
   * ޥ10˵(8˵+Ϥ)ζ̵ͭɽbitset.
   * ֤¦θ
   * 0-9 bit - Direction(UL=0, .., UUR=9)бޥޤŨλ1
   * 16-25 bit - Direction+16(UL=16, .., UUR=25)бޥλ1
   * ֤ǡޥ(3,3)ܤƤˡULбޥϡ(4,2)ǤϤʤ
   * (2,4)ؤ(2,4)UḶζ֤(3,3)򹶷Ǥ뤫
   */
  class NearMask
  {
    unsigned int mask;
    explicit NearMask(unsigned int value) : mask(value) {}
  public:
    NearMask() : mask(0) {}
    static const NearMask makeDirect(unsigned int value)
    {
      return NearMask(value);
    }
    /**
     * ޥ,Ĥ褦Ȥ, 10˵ξ֤֤
     * @param P(template) - ¦Υץ쥤䡼
     * @param Dir(template) - θĤΥޥ
     * @param state - ̤ɽ
     * @param target - Ĥޥ
     * @return 16ӥå(10ӥå)϶ޤŨλ1,ʳ0
     * 16ӥå(10ӥå) ϶λ1, ʳ0
     */
    template<Player P,Direction Dir>
    static const NearMask make(NumEffectState const& state,Position target) {
      /** ⤹¦Υޥ */
      Position pos=target-DirectionPlayerTraits<Dir,P>::offset();
      Piece p=state.getPieceAt(pos);
      if(p.canMoveOn<P>()){
	if(p.isEmpty()) 
	  return NearMask(0x10001<<static_cast<int>(Dir));
	return NearMask(1<<static_cast<int>(Dir));
      }
      return NearMask(0);
    }
    template<Player P>
    static const NearMask make(NumEffectState const& state,Position target) {
      NearMask nearMask;
      /**
       * 10˵ζξ֤å
       * NOTE: Statesignature effectλˤü첽®С
       * ٤
       */
      nearMask=NearMask::make<P,U>(state,target);
      nearMask|=NearMask::make<P,UL>(state,target);
      nearMask|=NearMask::make<P,UR>(state,target);
      nearMask|=NearMask::make<P,L>(state,target);
      nearMask|=NearMask::make<P,R>(state,target);
      nearMask|=NearMask::make<P,DL>(state,target);
      nearMask|=NearMask::make<P,D>(state,target);
      nearMask|=NearMask::make<P,DR>(state,target);
      nearMask|=NearMask::make<P,UUL>(state,target);
      nearMask|=NearMask::make<P,UUR>(state,target);
      return nearMask;
    }

    NearMask& operator|=(NearMask r) { mask |= r.mask; return *this; }
    NearMask& operator&=(NearMask r) { mask &= r.mask; return *this; }

    unsigned int spaceMask() const { return mask >> 16; }
    bool isSet(int n) const
    {
      return mask & (1<<n);
    }
    /**
     * on  bit offˤindex֤
     */
    int takeOneBit()
    {
      return misc::BitOp::takeOneBit(mask);
    }
    bool any() const { return mask; }
    unsigned int uintValue() const { return mask; }
  };

  inline const NearMask operator|(NearMask l, NearMask r) { 
    NearMask result = l;
    return result |= r;
  }
  inline const NearMask operator&(NearMask l, NearMask r) { 
    NearMask result = l;
    return result &= r;
  }
  inline bool operator==(NearMask l, NearMask r)
  {
    return l.uintValue() == r.uintValue();
  }
  inline bool operator!=(NearMask l, NearMask r)
  {
    return ! (l == r);
  }
  inline bool operator<(NearMask l, NearMask r)
  {
    return l.uintValue() < r.uintValue();
  }

  std::ostream& operator<<(std::ostream&, NearMask);
} // namespace container
  using container::NearMask;
} // namespace osl
#endif /* _NEARMASK_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
