/* sendOffPosition.h
 */
#ifndef _SENDOFFPOSITION_H
#define _SENDOFFPOSITION_H

#include "osl/state/numEffectState.h"
#include "osl/container/position8.h"
namespace osl
{
  namespace effect_util
  {
    struct Offset8 : public FixedCapacityVector<Offset,8>
    {
    };
    /** Τ褦ʶ̤ǼϤȯޥĴ */
    struct SendOffPosition
    {
      template <Player Attack>
      static bool onlyOneSupport(const NumEffectState& state, Position target)
      {
	const Piece p = state.getPieceAt(target);
	if (! p.isOnBoardByOwner<PlayerTraits<Attack>::opponent>())
	  return false;
	return state.hasEffectBy<Attack>(target) 
	  && (state.countEffect(alt(Attack), target) == 1);
      }
      template <Player Attack>
      static void find(const NumEffectState& state, Position king_position,
		       Position8& out);
      static void find(Player attack,
		       const NumEffectState& state, Position king_position,
		       Position8& out);
      struct Table
      {
	CArray<Offset,8> normal;
	CArray<Offset8,8> reverse;
	CArray<Offset8,256> reverse_all;
	Table();
      };
    private:
      static const Table table;
      template <Player Attack>
      static void testPosition(const NumEffectState& state, Position candidate,
			       int id, int& out)
      {
	if (onlyOneSupport<Attack>(state, candidate))
	{
	  out |= (1<<id);
	}
      }
    };
  } // namespace effect_util
} // namespace osl

#endif /* _SENDOFFPOSITION_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
