/* pin.h
 */

#ifndef EVAL_EXPERIMENTAL_PIN_H
#define EVAL_EXPERIMENTAL_PIN_H

#include "osl/ptype.h"
#include "osl/misc/carray.h"
#include "osl/state/numEffectState.h"
#include "osl/eval/experimental/weights.h"
#include "osl/eval/experimental/midgame.h"

namespace osl
{
  namespace eval
  {
    namespace experimental
    {
      class SimplePin
      {
	static CArray<int, PTYPE_SIZE> table;
      public:
	SimplePin() { };
	static void setUp(const Weights &weights);
	int eval(const NumEffectState &state,
		 PieceMask black_mask, PieceMask white_mask) const;
      };

      class Pin
      {
	static int index(const Position king,
			 const Piece piece)
	{
	  return std::abs(piece.position().x() - king.x()) * 17 +
	    (piece.owner() == BLACK ? (king.y() - piece.position().y()) :
	     (piece.position().y() - king.y())) + 8;
	}
	static CArray2d<MultiInt, PTYPE_SIZE, 17 * 9> table;
      public:
	enum { DIM = (osl::PTYPE_MAX - osl::PTYPE_PIECE_MIN + 1) * 17 * 9};
	Pin() { };
	static void setUp(const Weights &weights,int stage);
	static MultiInt eval(const NumEffectState &state,
			      PieceMask black_mask, PieceMask white_mask);
      };

    }
  }
}
#endif // EVAL_EXPERIMENTAL_PIN_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
