#ifndef _GENERATE_DROP_MOVES_TCC
#define _GENERATE_DROP_MOVES_TCC
#include "osl/move_generator/drop.h"
#include "osl/move_action/concept.h"
namespace osl 
{
  namespace move_generator
  {
    inline
    bool isPawnMaskSet(NumEffectState const& state,int x,misc::EmptyType /*pawnMask*/,Int2Type<BLACK>){
      return state.isPawnMaskSet<BLACK>(x);
    }
    inline
    bool isPawnMaskSet(NumEffectState const& state,int x,misc::EmptyType /*pawnMask*/,Int2Type<WHITE>){
      return state.isPawnMaskSet<WHITE>(x);
    }


    template<class Action>
    template<Player P,typename PawnMaskT,bool hasPawn,bool hasLance,bool hasKnight,bool hasSilver,bool hasGold,bool hasBishop,bool hasRook>
    void Drop<Action>::
    generateDropMoves(const NumEffectState& state,Action& action,PawnMaskT pawnMask)
    {
      if(hasPawn || hasLance || hasKnight || hasSilver || hasGold || hasBishop || hasRook){
	if(hasPawn){
	  if(hasLance || hasKnight || hasSilver || hasGold || hasBishop || hasRook){
	    for(int x=9;x>0;x--){
	      if(isPawnMaskSet(state,x,pawnMask,Int2Type<P>()))
		generateDropMovesX<P,false,hasLance,hasKnight,hasSilver,hasGold,hasBishop,hasRook>(state,action,x);
	      else
		generateDropMovesX<P,true,hasLance,hasKnight,hasSilver,hasGold,hasBishop,hasRook>(state,action,x);
	    }
	  }
	  else{
	    for(int x=9;x>0;x--){
	      if(!isPawnMaskSet(state,x,pawnMask,Int2Type<P>()))
		generateDropMovesX<P,true,hasLance,hasKnight,hasSilver,hasGold,hasBishop,hasRook>(state,action,x);
	    }
	  }
	}
	else{ // pawnʤ
	  for(int x=9;x>0;x--){
	    generateDropMovesX<P,false,hasLance,hasKnight,hasSilver,hasGold,hasBishop,hasRook>(state,action,x);
	  }
	}
      }
    }

    /**
     * Ԥɤ̵ǤƤʤȿ§򡤸ΨŪ˽褦ȤƤ褦
     */
    template<class Action>
    template<Player P,bool hasPawn,bool hasLance,bool hasKnight,bool hasSilver,bool hasGold,bool hasBishop,bool hasRook>
    void Drop<Action>::
    generateDropMovesX(const NumEffectState& state,Action& action,int x)
    {
      assert(hasPawn || hasLance || hasKnight || hasSilver || hasGold || hasBishop || hasRook);
      if(P==BLACK){
	if(hasSilver || hasGold || hasBishop || hasRook){
	  Position pos(x,1);
	  Piece p=state.getPieceAt(pos);
	  if(p==Piece::EMPTY()){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	  }
	}
	if(hasPawn || hasLance || hasSilver || hasGold || hasBishop || hasRook){
	  Position pos(x,2);
	  Piece p=state.getPieceAt(pos);
	  if(p==Piece::EMPTY()){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	    if(hasLance)
	      action.dropMove(pos,LANCE,P);
	    if(hasPawn)
	      action.dropMove(pos,PAWN,P);
	  }
	}
	for(int y=3;y<=9;y++){
	  Position pos(x,y);
	  Piece p=state.getPieceAt(pos);
	  if(p==Piece::EMPTY()){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	    if(hasKnight)
	      action.dropMove(pos,KNIGHT,P);
	    if(hasLance)
	      action.dropMove(pos,LANCE,P);
	    if(hasPawn)
	      action.dropMove(pos,PAWN,P);
	  }
	}
      }
      else{
	if(hasSilver || hasGold  || hasBishop || hasRook){
	  Position pos(x,9);
	  Piece p=state.getPieceAt(pos);
	  if(p==Piece::EMPTY()){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	  }
	}
	if(hasPawn || hasLance || hasSilver || hasGold|| hasBishop || hasRook){
	  Position pos(x,8);
	  Piece p=state.getPieceAt(pos);
	  if(p==Piece::EMPTY()){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	    if(hasLance)
	      action.dropMove(pos,LANCE,P);
	    if(hasPawn)
	      action.dropMove(pos,PAWN,P);
	  }
	}
	for(int y=7;y>=1;y--){
	  Position pos(x,y);
	  Piece p=state.getPieceAt(pos);
	  if(p==Piece::EMPTY()){
	    if(hasRook)
	      action.dropMove(pos,ROOK,P);
	    if(hasBishop)
	      action.dropMove(pos,BISHOP,P);
	    if(hasGold)
	      action.dropMove(pos,GOLD,P);
	    if(hasSilver)
	      action.dropMove(pos,SILVER,P);
	    if(hasKnight)
	      action.dropMove(pos,KNIGHT,P);
	    if(hasLance)
	      action.dropMove(pos,LANCE,P);
	    if(hasPawn)
	      action.dropMove(pos,PAWN,P);
	  }
	}
      }
    }

  } // namespace move_generator
} // namespace osl

template<class Action>
template<osl::Player P>
void osl::move_generator::Drop<Action>::
generateMoves(const NumEffectState& state,Action& action)
{
  if(state.template hasPieceOnStand<PAWN>(P))
    generateDropMovesPawn<P,misc::EmptyType,true>(state,action,misc::EmptyType());
  else
    generateDropMovesPawn<P,misc::EmptyType,false>(state,action,misc::EmptyType());
}

template<class Action>
template<osl::Player P,typename PawnMaskT,
	 bool hasPawn,bool hasLance,bool hasKnight,bool hasSilver,bool hasGold>
void osl::move_generator::Drop<Action>::
generateDropMovesGold(const NumEffectState& state,Action& action,PawnMaskT pawnMask)
{
  if(state.template hasPieceOnStand<BISHOP>(P))
    generateDropMovesBishop<P,PawnMaskT,hasPawn,hasLance,hasKnight,hasSilver,hasGold,true>(state,action,pawnMask);
  else
    generateDropMovesBishop<P,PawnMaskT,hasPawn,hasLance,hasKnight,hasSilver,hasGold,false>(state,action,pawnMask);
}


template<class Action>
template<osl::Player P>
void osl::move_generator::Drop<Action>::
generateMovesWithPawnMask(const NumEffectState& state,Action& action,BitXmask pawnMask)
{
  if(state.template hasPieceOnStand<PAWN>(P))
    generateDropMovesPawn<P,BitXmask,true>(state,action,pawnMask);
  else
    generateDropMovesPawn<P,BitXmask,false>(state,action,pawnMask);
}

#endif /* _GENERATE_DROP_MOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
