#ifndef _GENERATE_OPEN_MOVES_TCC
#define _GENERATE_OPEN_MOVES_TCC

#include "osl/move_generator/open.h"
#include "osl/move_generator/pieceOnBoard.tcc"
#include "osl/move_action/noAddEffectFilter.h"

namespace osl
{
  namespace move_generator
  {

    template <Player P>
    template<class Action,Ptype Type,PromoteType CanP,Direction Dir>
    // inline
    void Open<P>::
    generateMoveNotDir3(const NumEffectState& state,Piece p,Action& action,Position to,Int2Type<true>){
      // 
      // DirˤPromoteΥåɬ
      typedef move_action::NoAddEffectFilter<Action> action_t;
      action_t newAction(state,action,to);
      
      // to򺣤ϼΤƤƤ
      bits::PieceOnBoardDirUnsafe<P,Type,CanP,Dir>::
	generate(state,p.position(),newAction);
    }


    /** Ȥ礭Τ inline */
    template <Player P>
    template<class Action,Ptype Type,Direction Dir>
    void Open<P>::
    generateMoveNotDir(const NumEffectState& state,Piece p,Action& action,Position to){
      generateMoveNotDirSub<Action,Type,Dir>(state,p,action,to,Int2Type<PtypeTraits<Type>::canPromote>());
    }

    template <Player P> 
    template<class Action,Direction Dir>
    void Open<P>::
    generateOpenAttack(const NumEffectState& state,Piece p,Action& action,Position to){
      // 
      assert(p.owner()==P);
      switch(p.ptype()){
      case PAWN: generateMoveNotDir<Action,PAWN,Dir>(state,p,action,to); break;
      case LANCE: generateMoveNotDir<Action,LANCE,Dir>(state,p,action,to); break;
      case KNIGHT: generateMoveNotDir<Action,KNIGHT,Dir>(state,p,action,to); break;
      case SILVER: generateMoveNotDir<Action,SILVER,Dir>(state,p,action,to); break;

      case GOLD:     generateMoveNotDir<Action,GOLD,Dir>(state,p,action,to); break;
      case PPAWN:    generateMoveNotDir<Action,PPAWN,Dir>(state,p,action,to); break;
      case PLANCE:   generateMoveNotDir<Action,PLANCE,Dir>(state,p,action,to); break;
      case PKNIGHT:  generateMoveNotDir<Action,PKNIGHT,Dir>(state,p,action,to); break;
      case PSILVER:  generateMoveNotDir<Action,PSILVER,Dir>(state,p,action,to); break;

      case BISHOP:  generateMoveNotDir<Action,BISHOP,Dir>(state,p,action,to); break;
      case PBISHOP:  generateMoveNotDir<Action,PBISHOP,Dir>(state,p,action,to); break;
      case ROOK:  generateMoveNotDir<Action,ROOK,Dir>(state,p,action,to); break;
      case PROOK:  generateMoveNotDir<Action,PROOK,Dir>(state,p,action,to); break;
      case KING:  generateMoveNotDir<Action,KING,Dir>(state,p,action,to); break;
      default: abort();
      }
    }

  } // namespace move_generator
} // namespace osl

template<osl::Player P>
template<class Action>
void osl::move_generator::Open<P>::
generate(const NumEffectState& state,Piece p,Action& action,Position to,Direction dir)
{
  switch(dir){
  case UL: generateOpenAttack<Action,UL>(state,p,action,to); break;
  case U: generateOpenAttack<Action,U>(state,p,action,to); break;
  case UR: generateOpenAttack<Action,UR>(state,p,action,to); break;
  case L: generateOpenAttack<Action,L>(state,p,action,to); break;
  case R: generateOpenAttack<Action,L>(state,p,action,to); break;
  case DL: generateOpenAttack<Action,UR>(state,p,action,to); break;
  case D: generateOpenAttack<Action,U>(state,p,action,to); break;
  case DR: generateOpenAttack<Action,UL>(state,p,action,to); break;
  default: assert(0);
  }
}

#endif /* _GENERATE_OPEN_MOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
