/* usi.h
 */
#ifndef _USI_H
#define _USI_H

#include "osl/move.h"
#include "osl/container/moveVector.h"
#include <string>
#include <stdexcept>

namespace osl
{
  namespace state
  {
    class SimpleState;
  }
  namespace record
  {
    namespace usi
    {
      const Move strToMove(const std::string&, const state::SimpleState&);
      PtypeO charToPtypeO(char);

      const std::string show(Move);

      class ParseError : public std::invalid_argument
      {
      public:
        ParseError(const std::string& msg = "")
          : invalid_argument(msg)
        { }
      };

      /** 
       * ̤. 
       * boardʸʤȤϡParseErrorthrow. 
       * @param board USIʸ
       * @param state boardβϷ̤Ϥ
       */
      void parseBoard(const std::string& board, state::SimpleState&);
      /**  [sfen <sfenstring> | startpos ] moves <move1> ... <movei> */
      void parse(const std::string& line, state::SimpleState&);
      void parse(const std::string& line, state::SimpleState& initial, MoveVector& moves);

      /** 
       * URIFile systemȤƻȤ褦ˡʸescape. 
       * GPSˤĥǤꡢstandardǤϤʤ.
       * @str strΤ
       */
      void escape(std::string& str);
      /** 
       * escape줿ʸ򸵤᤹.
       * GPSˤĥǤꡢstandardǤϤʤ.
       * @str strΤ
       */
      void unescape(std::string& str);
    }
  } // record
} // osl

#endif /* _USI_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
