/* tableAnalyzer.h
 */
#ifndef _TABLE_ANALYZER_H
#define _TABLE_ANALYZER_H

#include "osl/hash/hashKey.h"
#include <iosfwd>

namespace osl
{
  namespace search
  {
    class SimpleHashTable;
    class SimpleHashRecord;
    class SearchMoveList;
    namespace analyzer
    {
      /**
       * õΥơ֥ʬ.
       * ꤷͤ +,  -, lower bound  L, upper bound  U ɽ
       *
       * Ū 
       * - +L ޤäƤ̤ϡ
       *   Τ٤Ƥμ(ؤζ) -U 
       * - +U ޤäƤ̤ϡ
       *   ξʤȤĤμ -L 
       */
      class TableAnalyzer
      {
	const SimpleHashTable& table;
	std::ostream & os;
      public:
	TableAnalyzer(const SimpleHashTable&, std::ostream&);
	~TableAnalyzer();
    
	/**
	 * ɽĴ٤Ϳ줿̤ξ̤θĴ٤.
	 * õ root  (best move ޤäƤ) 
	 *
	 * - ΰϡ+L (= -U)
	 * - ʳμˤϡ+U (= -L)
	 *
	 * 뤳Ȥǧ
	 */
	void examineTopLevel(const HashKey& key, int num_print_moves) const;
	/**
	 * ɽĴ٤Ϳ줿̤ξ̤θĴ٤.
	 * õ root ̤ best move ؤ
	 *
	 * Ƽ +U 뤳Ȥǧ
	 */
	void examineUpperBounds(const HashKey& key, int num_print_moves) const;

	static void makeBestMoveList(const SimpleHashRecord *, SearchMoveList&,
				     int max);
      };
    } // namespace analyzer
  } // namespace search
  using search::analyzer::TableAnalyzer;
} // namespace osl

#endif /* _TABLE_ANALYZER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
