/* enterKing.cc
 */
#include "osl/enter_king/enterKing.h"

bool osl::enter_king::EnterKing::canDeclareWin(const NumEffectState& state)
{
  if (state.getTurn() == BLACK)
    return canDeclareWin<BLACK>(state);
  else
    return canDeclareWin<WHITE>(state);
}

template <osl::Player Turn>
bool
osl::enter_king::EnterKing::canDeclareWin(const NumEffectState& state)
{
  //, ֤Ͼά
  assert(Turn == state.getTurn());
  const Position myKingPosition
    = state.getKingPosition(Turn);

  //꤬äƤʤ
  if ( state.hasEffectBy(alt(Turn), myKingPosition) )
    return false;

  //̤Ũؤˤ뤫
  //ʤ1~3
  //ʤ7~9
  const int y = myKingPosition.y();
  const int enemyCampMin = (Turn==BLACK) ? 1 : 7;
  const int enemyCampMax = enemyCampMin + 2;

  if( (y < enemyCampMin) || (y > enemyCampMax) )
    return false;

  // Ũؤ˼ʬζ10ʾ (̤) 뤫
  // ꤹ.  (о: Ũؤζ + )
  // 5Ȥ, 28, ʤ27ɬ
  int countPiece = 0;
  int onEnemyCamp = -1; // ̤ʬͽƤ

  for (int i = enemyCampMin; i <= enemyCampMax; i++)
    for (int j=1; j<=9; j++){
      Piece pieceOnEnemyCamp = state.getPieceOnBoard(Position(j,i));
      if (pieceOnEnemyCamp.isOnBoardByOwner<Turn>()) {
	++countPiece;
	onEnemyCamp += 1 + 4 * isMajor(pieceOnEnemyCamp.ptype());
      }
    }

  if (countPiece < 11)
    return false;

  int onStand =
    5 * state.countPiecesOnStand<ROOK>(Turn)
    + 5 * state.countPiecesOnStand<BISHOP>(Turn)
    + state.countPiecesOnStand<GOLD>(Turn)
    + state.countPiecesOnStand<SILVER>(Turn)
    + state.countPiecesOnStand<KNIGHT>(Turn)
    + state.countPiecesOnStand<LANCE>(Turn)
    + state.countPiecesOnStand<PAWN>(Turn);

  if ( onEnemyCamp + onStand < 27 + (Turn==BLACK) )
    return false;

  return true;
}

namespace osl
{
  namespace enter_king
  {
    template bool osl::enter_king::EnterKing::canDeclareWin<BLACK>(const NumEffectState&);
    template bool osl::enter_king::EnterKing::canDeclareWin<WHITE>(const NumEffectState&);
  }
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
