/* pool_allocator.cc
 */
#include "osl/stl/pool_allocator.h"
#include <stdexcept>
#include <iostream>

#ifdef USE_TBB_SCALABLE_ALLOCATOR
const int osl::stl::gpl_pool_allocator_used=-1;
#else
#ifdef USE_GPL_POOL_ALLOCATOR
const int osl::stl::gpl_pool_allocator_used=1;
#else
const int osl::stl::gpl_pool_allocator_used=0;
#endif
#endif

osl::stl::
ConsistencyCheck::ConsistencyCheck(int value)
{
  if (value != gpl_pool_allocator_used)
  {
    const char *error = "compile option error! USE_GPL_POOL_ALLOCATOR inconsistency";
    std::cerr << error << "\n";
    std::cerr << value << " != " << gpl_pool_allocator_used << "\n";
    throw std::logic_error(error);
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
