/* psn.t.cc
 */
#include "osl/record/psn.h"
#include "osl/state/simpleState.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

class PsnTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(PsnTest);
  CPPUNIT_TEST(testMove);
  CPPUNIT_TEST_SUITE_END();
 public:
  void testMove();
};

CPPUNIT_TEST_SUITE_REGISTRATION(PsnTest);

using namespace osl;
using namespace osl::record;

void PsnTest::testMove()
{
  SimpleState state(HIRATE);
  const Move m76fu = Move(Position(7,7), Position(7,6), PAWN, 
			     PTYPE_EMPTY, false, BLACK);
  const std::string psn76fu = "7g7f";
  const Move m76fu2 = psn::strToMove(psn76fu, state);
  CPPUNIT_ASSERT_EQUAL(m76fu, m76fu2);

  const std::string psn76fu2 = psn::show(m76fu);
  CPPUNIT_ASSERT_EQUAL(psn76fu, psn76fu2);
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
